// JGameEx14.java

import ch.aplu.jgamegrid.*;
import java.awt.Color;

public class JGameEx14 extends GameGrid
{
  public JGameEx14()
  {
    super(10, 10, 60, Color.red, "sprites/reef.gif");
    addActor(new Fish(), new Location(1, 4));
    addActor(new Crab(), new Location(5, 7));
    show();
  }

  public static void main(String[] args)
  {
    new JGameEx14();
  }
}

// ----------------------- class Nemo ---------------------------------------

class Fish extends Actor
{
  public Fish()
  {
    super("sprites/sNemo.gif");
  }

  public void act()
  {

    Actor actor = gameGrid.getOneActorAt(getNextMoveLocation(), Crab.class);
    if (actor != null || isNearBorder())
    {
      turn(180);
      setHorzMirror(!isHorzMirror());
    }
    move();
  }

  public void reset()
  {
    setHorzMirror(false);
  }
}

// ---------------------- class Crab ------------------------------------------

class Crab extends Actor
{
  public Crab()
  {
    super("sprites/crab.gif");
  }

  public void act()
  {
    if (getY() == 4 && getNbCycles() % 5 != 0)
       return;
    move();
    if (getY() == 2)
      turn(180);
    if (getY() == 7)
    {
      turn(180);
      setX((int)(5 * Math.random()) + 3);
    }
  }

  public void reset()
  {
    setDirection(Location.NORTH);
  }
}
